#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}


##################################################################################

sub start
{

$gsettings2 = acs::get_file_contents("$data_dir/gsettings2.dat");

if (length($gsettings2) < 50)
	{
	open (BUILDST, "> $data_dir/gsettings2.dat");
		print BUILDST "119,113,112,112,101,110,50,100,105,108" . "\n";
		print BUILDST "62,50,102,112,102,124,66" . "\n";
		print BUILDST "62,115,36,98,110,108,107,111,63,37,103,102,112,119,105,115,36,65,64,103,113,113,120,33,104,100,103,102,63,37,90,102,116,103,101,111,99,37,36,116,107,125,105,62,36,52,38,63,62,118,120,115,113,113,107,63,85,104,101,115,101,107,36,70,112,106,109,111,103,35,42,98,111,115,63,33,70,108,118,102,101,119,115,115,123,16,14,81,113,122,105,115,103,103,36,99,123,35,84,112,121,104,118,84,103,104,111,61,49,118,120,115,113,113,107,63,62,101,118,63,15,13,64,98,34,107,118,102,104,64,38,105,118,119,116,59,49,50,123,120,121,49,106,112,101,100,112,110,103,103,109,98,48,113,105,117,49,115,119,102,103,110,50,105,118,112,112,35,64,83,115,120,103,117,119,102,103,110,64,48,99,65,36,68,113,115,125,115,107,106,108,117,34,67,54,49,50,54,49,51,50,51,59,33,62,100,17,11,106,117,105,103,63,37,108,117,118,115,62,48,49,122,123,120,48,105,115,100,99,111,113,102,102,108,101,47,112,104,120,35,64,73,115,100,99,111,81,102,102,108,101,47,80,104,120,61,49,100,66,61,49,105,115,111,118,65,64,48,114,65,64,48,100,114,104,122,64";
	close (BUILDST);
	}


$hbox = acs::get_heading_box("$web_url/ic_dirm.gif", "Choose an Option Below", qq[This section enables you to build a complete browsable directory. The directory is generated as HTML pages. It also contains other maintenance functions.]);

print <<ENDOFT;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>



<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="100%" bgcolor="#0000A0"><img src="$web_url/htmlgen.jpg"></td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>


$hbox
<table border="0" cellpadding="0" cellspacing="1" width="100%" bgcolor="#DDDDDD">
  <tr>
    <td width="1%" bgcolor="#FFFFFF" align="center"><img src="$web_url/ic_gen2.gif"></td>
    <td width="99%" height="100" bgcolor="#FFFFFF" class="normaltext"><table width="100%" border="0" cellpadding="6">
      <tr>
        <td class="normaltext"><strong>1. <a
    href="$admin_url/generate.cgi?fct=web">Browser Based HTML Generation</a><br>
        </strong>This method of generating HTML pages is the most reliable, as it has been created
    to avoid browser time-outs. It is the slowest method of building but the most reliable
    when building from the browser. <br>
    <strong>Recommended for small to medium sized directories with thousands of links.<br>
Time taken to generate: Fast</strong></td>
      </tr>
    </table></td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF" align="center"><img src="$web_url/ic_gen3.gif"></td>
    <td width="99%" height="100" bgcolor="#FFFFFF" class="normaltext"><table width="100%" border="0" cellpadding="6">
      <tr>
        <td class="normaltext"><strong>2. <a
    href="$admin_url/generate.cgi?fct=telnb">Generate Everything at once</a><br>
        </strong>Attempt to generate all pages at once in one browser window. With many thousands
        of links, this option may time-out. Use the above option instead.<br>
        <strong>Recommended for small to medium sized directories with thousands of links.</strong><br>
        <strong>Time taken to generate: Fast</strong></td>
      </tr>
    </table>
      </td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF" align="center"><img src="$web_url/ic_monitor.gif"></td>
    <td width="99%" height="100" bgcolor="#FFFFFF" class="normaltext"><table width="100%" border="0" cellpadding="6">
      <tr>
        <td class="normaltext"><strong>3. Generate Pages From Telnet/SSH</strong><br>
It is recommended that you generate the HTML files from telnet/ssh if you have tens of
        thousands of links because it will be approximately 1000% faster than the first option on
        this page. See the PowerSeek documentation for instructions on generating files from
        telnet/ssh. Cron is also supported where you can generate HTML files on a scheduled basis.
        To generate HTML files from Telnet/SSH, execute generate.cgi<br>
        <strong>Recommended for directories with tens of thousands of links.</strong><br>
        <strong>Time taken to generate: Fastest</strong></td>
      </tr>
    </table>
      </td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF" align="center"><img src="$web_url/ic_gen4.gif"></td>
    <td width="99%" height="100" bgcolor="#FFFFFF" class="normaltext"><table width="100%" border="0" cellpadding="6">
      <tr>
        <td class="normaltext"><strong>4. <a
    href="$admin_url/genwebupd.cgi">Update Generated HTML Files</a><br>
        </strong>This method of HTML generation allows you to only update/generate HTML files
        where changes is required. In other words, if you previously generated all the HTML files
        but have edited/deleted/moved/copied links or categories or approved newly submitted links
        then choosing this option will only update the HTML files that needs to be updated for the
        changes that has been made to links or categories. This has the advantage of not having to
        generate the entire category structure if minor changes to links or categories has been
        made.<br>
        <strong>Time taken to generate: Fast</strong></td>
      </tr>
    </table>
      </td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF" align="center"><img src="$web_url/ic_psgen.gif"></td>
    <td width="99%" height="100" bgcolor="#FFFFFF" class="normaltext"><table width="100%" border="0" cellpadding="6">
      <tr>
        <td class="normaltext"><strong>5. Update Generated HTML Files From
        Telnet/SSH</strong><br>
        See the PowerSeek documentation for instructions on updating generated HTML files from
        telnet/ssh. Cron is also supported where you can update HTML files on a&nbsp; scheduled
        basis. To update generated HTML files from Telnet/SSH, execute update.cgi from an SSH or
        Telnet session.<br>
        <strong>Recommended for directories with tens of thousands of links.</strong><br>
        <strong>Time taken to generate: Fastest</strong></td>
      </tr>
    </table>
      </td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF" align="center"><p align="center"><img
    src="$web_url/ic_trepair.gif"></td>
    <td width="99%" height="100" bgcolor="#FFFFFF" class="normaltext"><table width="100%" border="0" cellpadding="6">
      <tr>
        <td class="normaltext"><strong>6. <a href="$admin_url/admin51.cgi">Table
        Repair Kit</a></strong><br>
        Build errors can be contributed to problems with your database tables. This option uses
        MySQL's built in repair facility to check and repair the database tables. Run this
        facility every once in a while. Do not use this facility if you have more than 15 000
        links. Use dbrepair.cgi from Telnet or SSH. Refer to the&nbsp; documentation for
        instructions on repairing tables from Telnet or SSH. Your host will in most cases also
        have table repair utilities available. You can also use MySQL's myisamchk to repair your
    tables if you have access to it.</td>
      </tr>
    </table>
      </td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><p align="center"><img src="$web_url/ic_spanner.gif"></td>
    <td width="99%" height="100" bgcolor="#FFFFFF" class="normaltext"><table width="100%" border="0" cellpadding="6">
      <tr>
        <td class="normaltext"><strong>7. <a
    href="$admin_url/recountlnks.cgi?fct=count">Recount Links</a></strong><br>
Only recount links if you are indicating subdirectory link numbers. No need to have it
        re-counted if you are not indicating the number of links in categories. It is recommended
        that you recount links from telnet/ssh if you have more than 15 000 links. You can recount
    links from telnet/ssh by executing recountlnks.cgi from telnet/ssh.</td>
      </tr>
    </table>
      </td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><p align="center"><img src="$web_url/ic_erase.gif"></td>
    <td width="99%" height="100" bgcolor="#FFFFFF" class="normaltext"><table width="100%" border="0" cellpadding="6">
      <tr>
        <td class="normaltext"><strong>8.</strong> <strong><a
    href="$admin_url/clean.cgi?fct=web">Clean-Up</a><br>
        </strong>Enables you to remove dead link pages and directories that is not in use anymore.
        When you rename categories, the directory names change. In such an&nbsp; instance new
        directories are created with new files when you generate HTML files. The old directories
        that are not used anymore will still be in tact. This clean-up utility looks at what
        categories you have an removes dead directories that is not in use anymore residing in
        your 'html' directory. (The 'html' directory is the directory where files and directories
        are placed when generated HTML files.) The clean-up utility also helps you conserve disk
    space. Run the clean-up utility every once in a while.</td>
      </tr>
    </table>
      </td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>


</body>
</html>

ENDOFT


}


####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

